NIWI:= function(m,I,w) #assuming that w normalises W_I, returns [n_I,w_I] such that w=n_Iw_I
local W, bool, i, SI, w0I, wI, nI;
W:=CoxeterGroupByCoxeterMatrix(m);
w0I:=[]; 

SI:=[];
for i in I do 
	Add(SI,EltWord(W,[i]));
od;

for x in Elements(Subgroup(W,SI)) do
	bool:=true;
	for i in SI do
		if not CoxeterLength(W,i^(w*x))=1 then
			bool:=false;
		fi;
	od;
	if bool then
		w0I:= Union(w0I,[1/x]);
	fi;
od;

wI:= First(w0I, x -> ForAll(SI, i -> CoxeterLength(W,w*x^(-1)*i) = CoxeterLength(W,w*x^(-1))+1));
nI:= w*wI^(-1);

return [nI,wI];
end;