Root:= function(m,w) #returns (n,x) such that w=x^n with \ell(w)=n\ell(x) and n max
local W, n, x, d, lw, ww, i;
W:=CoxeterGroupByCoxeterMatrix(m);
lw:=CoxeterLength(W,w);

n:=1; x:=w;
for d in DivisorsInt(lw) do
	for ww in ReducedExpressions(W,w) do
		if ForAll([1..d], i -> ww{[(i-1)*lw/d+1..i*lw/d]}=ww{[1..lw/d]}) then
			n := d;
			x:= EltWord(W,ww{[1..lw/d]});
		fi;
	od;
od;
return [n,x];
end;

