Cyc:=function(m,w) # returns the cyclic shift class of w
local W, t, s, r, x, i;
W:=CoxeterGroupByCoxeterMatrix(m); t:=[[w]]; s:=[]; r:=1;
while not IsSubset(s,t[r]) do
	t[r+1]:=[];
	for x in Difference(t[r],s) do
		for i in [1..DimensionsMat(m)[1]] do
			if CoxeterLength(W,x^EltWord(W,[i])) <= CoxeterLength(W,x) then
				t[r+1] := Union(t[r+1],[x^EltWord(W,[i])]);
			fi;
		od;
	od;
	s := Union(s,t[r]); r:=r+1;
od;
return s;
end;